Bug 1420197 - [Docs][RFE][Admin] Document the procedure for sparsifying a virtual disk
Summary: [Docs][RFE][Admin] Document the procedure for sparsifying a virtual disk
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Red Hat Enterprise Virtualization Manager
Classification: Red Hat
Component: Documentation
Version: 4.1.0
Hardware: Unspecified
OS: Unspecified
high
unspecified
Target Milestone: ovirt-4.1.1
: ---
Assignee: Emma Heftman
QA Contact: Byron Gravenorst
URL:
Whiteboard:
Depends On: 734120
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-02-08 05:40 UTC by Lucy Bopf
Modified: 2019-05-07 13:13 UTC (History)
9 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-03-14 11:43:59 UTC
oVirt Team: Docs
Target Upstream Version:


Attachments (Terms of Use)

Description Lucy Bopf 2017-02-08 05:40:07 UTC
With this update, the ability to sparsify a thin-provisioned disk has been added to Red Hat Virtualization. When a virtual machine is shut down the user can sparsify the disk to convert the free space within the disk image back to free space on the host.

A procedure for this must be added to the documentation.

Comment 1 Lucy Bopf 2017-02-16 04:29:13 UTC
Assigning to Emma for review.

Comment 2 Emma Heftman 2017-02-21 14:37:52 UTC
I have increased the initial estimate from 8 to 16 as the feature has several constraints involving the storage domain and disk type that is being sparsified.
Each of these constraints needs to be understood clearly, documented and a link to the other parts of the documentation that describes these features.

In addition, there may be a requirement to document this feature from the API and not only from the UI. If that is the case I will increase the estimate again.

Comment 3 Emma Heftman 2017-02-21 17:19:44 UTC
Shmuel, please help me with the following questions.

1.  in order to document this feature, please list all limitations that should appear in the documentation.
From what I have learnt from Sefi, this should include 

1. a list of NFS 4.2
2. No support for preallocated
3. No support for local file storage.
4. No support for Direct LUN
5. No support for Cinder


Anything else?

2. I understand that there is a button in hte UI and an aPI option. Does the API also need to be documented?

3. IS  Sparsify supported in Storage Domains defined as Posix?

Comment 4 Emma Heftman 2017-02-21 18:03:48 UTC
(In reply to emma heftman from comment #3)
> Shmuel, please help me with the following questions.
> 
> 1.  in order to document this feature, please list all limitations that
> should appear in the documentation.
> From what I have learnt from Sefi, this should include 
> 
> 1. a list of NFS 4.2
> 2. No support for preallocated
> 3. No support for local file storage.
> 4. No support for Direct LUN
> 5. No support for Cinder
> 
> 
> Anything else?
> 
> 2. I understand that there is a button in hte UI and an aPI option. Does the
> API also need to be documented?
> 
> 3. IS  Sparsify supported in Storage Domains defined as Posix?

4. Does the VM need to be shut down before doing this?

Comment 5 Yaniv Kaul 2017-02-21 18:07:28 UTC
(In reply to emma heftman from comment #4)
> (In reply to emma heftman from comment #3)
> > Shmuel, please help me with the following questions.
> > 
> > 1.  in order to document this feature, please list all limitations that
> > should appear in the documentation.
> > From what I have learnt from Sefi, this should include 
> > 
> > 1. a list of NFS 4.2

or an iSCSI or FC or local domain that support DISCARD functionality.
I think Gluster does not, for the time being.

> > 2. No support for preallocated

Yeh, not sure why... Should be supported.

> > 3. No support for local file storage.

Not sure why...

> > 4. No support for Direct LUN

Correct.

> > 5. No support for Cinder

Correct.

> > 
> > 
> > Anything else?
> > 
> > 2. I understand that there is a button in the UI and an aPI option. Does the
> > API also need to be documented?

Isn't it auto-magically documented?

> > 
> > 3. IS  Sparsify supported in Storage Domains defined as Posix?

Good question. I would support it, but I'm not sure if it is.

> 
> 4. Does the VM need to be shut down before doing this?


Yes.

Comment 6 Emma Heftman 2017-02-22 10:47:33 UTC
Thanks Yaniv.

Shmuel

In addition to the open issues that remain after Yaniv's feedback, please answer this additional issue:

5. The feature page discusses the following features. Please confirm which have been developed:

 - Support for sparsifying multiple disks

- An indication of the actual disk size.

- An indication that the disk needs to be sparsified if less then X% remains.

Comment 7 Shmuel Melamud 2017-02-22 15:36:53 UTC
Unfortunately, the feature page for virt-sparsify is very outdated. I've wrote a new text, but it is still not approved. You can read it in my pull request here: https://github.com/oVirt/ovirt-site/pull/772/commits/7e4d76881572210f70f1ee21ca1b1e6d406ec92f

Also I've demonstrated the feature and how it is implemented in Deep Dive: https://www.youtube.com/watch?v=ayseKlGLwHI&feature=share

Comment 8 Shmuel Melamud 2017-02-22 15:53:02 UTC
> 2. No support for preallocated

Sparsify for preallocated is disabled because the goal of creation of a preallocated disk is to exploit the advantage of allocation of the whole disk in advance. Sparsify deallocates portions of the disk which is opposite to the goal the preallocated disk was created for.

> 3. No support for local file storage.

Local disk partitions are not supported like any direct LUNs. But local file storage is similar to NFS directories and should be supported. Did Sefi tested it?

> 2. I understand that there is a button in hte UI and an aPI option. Does the
> API also need to be documented?

REST API has its own documentation auto-generated from the source code.

> 3. IS  Sparsify supported in Storage Domains defined as Posix?

As far as I know, the POSIX Storage Domains also use NFS so they should be supported for NFS 4.2 and higher. But somebody from storage team must confirm this.

> - Support for sparsifying multiple disks

Yes.

> - An indication of the actual disk size.

No.

> - An indication that the disk needs to be sparsified if less then X% remains.

No.

Comment 9 Emma Heftman 2017-02-23 10:35:54 UTC
(In reply to Shmuel Melamud from comment #8)
> > 2. No support for preallocated
> 
> Sparsify for preallocated is disabled because the goal of creation of a
> preallocated disk is to exploit the advantage of allocation of the whole
> disk in advance. Sparsify deallocates portions of the disk which is opposite
> to the goal the preallocated disk was created for.
> 
> > 3. No support for local file storage.
> 
> Local disk partitions are not supported like any direct LUNs. But local file
> storage is similar to NFS directories and should be supported. Did Sefi
> tested it?

Sefi, please let us know whether you have tested this scenario.


> 
> > 2. I understand that there is a button in hte UI and an aPI option. Does the
> > API also need to be documented?
> 
> REST API has its own documentation auto-generated from the source code.
> 
> > 3. IS  Sparsify supported in Storage Domains defined as Posix?
> 
> As far as I know, the POSIX Storage Domains also use NFS so they should be
> supported for NFS 4.2 and higher. But somebody from storage team must
> confirm this.

Shmuel, could you please follow up with the storage team and let me know. When I asked them today they did not know the answer.


> > - Support for sparsifying multiple disks
> 
> Yes.
> 
> > - An indication of the actual disk size.
> 
> No.
> 
> > - An indication that the disk needs to be sparsified if less then X% remains.
> 
> No.

Comment 10 sefi litmanovich 2017-02-23 15:03:20 UTC
(In reply to emma heftman from comment #9)
> (In reply to Shmuel Melamud from comment #8)
> > > 2. No support for preallocated
> > 
> > Sparsify for preallocated is disabled because the goal of creation of a
> > preallocated disk is to exploit the advantage of allocation of the whole
> > disk in advance. Sparsify deallocates portions of the disk which is opposite
> > to the goal the preallocated disk was created for.
> > 
> > > 3. No support for local file storage.
> > 
> > Local disk partitions are not supported like any direct LUNs. But local file
> > storage is similar to NFS directories and should be supported. Did Sefi
> > tested it?
> 
> Sefi, please let us know whether you have tested this scenario.

1. Didn't test it so far, but did today and found the following bug: https://bugzilla.redhat.com/show_bug.cgi?id=1426265

2. Not sure what's the meaning of 'Local disk partitions' in this context, please explain.


> 
> 
> > 
> > > 2. I understand that there is a button in hte UI and an aPI option. Does the
> > > API also need to be documented?
> > 
> > REST API has its own documentation auto-generated from the source code.
> > 
> > > 3. IS  Sparsify supported in Storage Domains defined as Posix?
> > 
> > As far as I know, the POSIX Storage Domains also use NFS so they should be
> > supported for NFS 4.2 and higher. But somebody from storage team must
> > confirm this.
> 
> Shmuel, could you please follow up with the storage team and let me know.
> When I asked them today they did not know the answer.
> 
> 
> > > - Support for sparsifying multiple disks
> > 
> > Yes.
> > 
> > > - An indication of the actual disk size.
> > 
> > No.
> > 
> > > - An indication that the disk needs to be sparsified if less then X% remains.
> > 
> > No.

Comment 14 Emma Heftman 2017-02-28 16:34:53 UTC
Hi Byron. Please review and approve the following merge request:

https://gitlab.cee.redhat.com/rhci-documentation/docs-Red_Hat_Enterprise_Virtualization/merge_requests/355

Comment 18 Emma Heftman 2017-03-14 11:43:59 UTC
The updated documentation is now available on the customer portal:

https://access.redhat.com/documentation/en-us/red_hat_virtualization/4.1-beta/html-single/administration_guide/#sect-Virtual_Disk_Tasks

See section 11.6.12. Reclaiming Virtual Machine Disk Space


Note You need to log in before you can comment on or make changes to this bug.